#ifndef TARTANALOOP_HH
#define TARTANALOOP_HH

class TArtEventStore;

class TArtAnaFile;

class TArtAnaLoop
{
  friend class TArtAnaLoopStatic;
  friend class TArtAnaLoopManager;

public:
  TArtAnaLoop();
  virtual ~TArtAnaLoop();

  virtual bool OpenAnaFile(const char* anafilename);
  virtual void AnaLoop(const char* filename = 0, int eventnumber = -1);
  virtual const char* ClassName() const = 0;
  virtual int GetEventNumber() const {return fNumEvents;}

protected:
  virtual void Construct() = 0;
  virtual void Calculate() = 0;
  virtual void Destruct() = 0;

  TArtAnaFile* fAnaFile;

private:
  virtual void Wait();

  TArtEventStore *fEventStore;
  int fNumEvents;
};

#endif
