#ifndef _TARTNEBULAPLA_H_
#define _TARTNEBULAPLA_H_

#include "TObject.h"
#include "TString.h"

#include <iostream>

class TArtNEBULAPla : public TObject
{
public:
  TArtNEBULAPla()
    : TObject(), fDataState(0), fIHitMin(0),
      fID(-1), fName(""), fFPl(-1), fLayer(-1), fSubLayer(-1),
      fRawTU(-1), fRawTD(-1), fRawQU(-1), fRawQD(-1), fTime(-1), fEnergy(-1)
  {
    for(int i=0; i<3; ++i) fPos[i] = -1000;
  }
  virtual ~TArtNEBULAPla(){;}

  virtual void SetDataState(Int_t val){fDataState = val;}
  virtual void SetIHitMin(Int_t val){fIHitMin = val;}
  virtual Int_t GetDataState() const {return fDataState;}
  virtual Int_t GetIHitMin() const {return fIHitMin;}

  virtual void SetID(Int_t val){fID = val;}
  virtual void SetDetectorName(const TString& val){fName = val;}
  virtual void SetFPl(Int_t val){fFPl = val;}
  virtual void SetLayer(Int_t val){fLayer = val;}
  virtual void SetSubLayer(Int_t val){fSubLayer = val;}
  virtual void SetPos(const Double_t* val)
  {for(int i=0; i<3; ++i){fPos[i] = val[i];}}
  virtual void SetPos(Double_t val, Int_t i){fPos[i] = val;}
  virtual void SetRawTU(Int_t val){fRawTU = val;}
  virtual void SetRawTD(Int_t val){fRawTD = val;}
  virtual void SetRawQU(Int_t val){fRawQU = val;}
  virtual void SetRawQD(Int_t val){fRawQD = val;}
  virtual void SetEnergy(Double_t val){fEnergy = val;}
  virtual void SetTime(Double_t val){fTime = val;}

  virtual Int_t GetID() const {return fID;}
  virtual const TString& GetDetectorName() const {return fName;}
  virtual Int_t GetFPl() const {return fFPl;}
  virtual Int_t GetLayer() const {return fLayer;}
  virtual Int_t GetSubLayer() const {return fSubLayer;}
  virtual const Double_t* GetPos() const {return fPos;}
  virtual Double_t GetPos(int i) const {return fPos[i];}
  virtual Int_t GetRawTU() const {return fRawTU;}
  virtual Int_t GetRawTD() const {return fRawTD;}
  virtual Int_t GetRawQU() const {return fRawQU;}
  virtual Int_t GetRawQD() const {return fRawQD;}
  virtual Double_t GetEnergy() const {return fEnergy;}
  virtual Double_t GetTime() const {return fTime;}

private:
  // fDataState<0:invalid, fDataState==0:initial, fDataState>0:valid
  Int_t fDataState;
  Int_t fIHitMin;

  Int_t fID;
  TString fName;
  Int_t fFPl;
  Int_t fLayer;  
  Int_t fSubLayer;  
  Double_t fPos[3];

  Int_t fRawTU;  
  Int_t fRawTD;  
  Int_t fRawQU;  
  Int_t fRawQD;  

  Double_t fTime;  
  Double_t fEnergy;  

  ClassDef(TArtNEBULAPla,1);
};
#endif

